<template>
  <div class="rule draggable" :class="{error: isWrong}">
    <div class="rule-content">
      <div class="rule-content-lhs">
        {{ rule.lhs }}
      </div>
      <div class="rule-content-arrow">
        ⟶
      </div>
      <div class="rule-content-rhs">
        {{ rule.rhs }}
      </div>
    </div>
    <div v-if="column.isEditable" class="rule-action" @click="removeRule(rule)">
      <DeleteOutlineIcon :size="18"></DeleteOutlineIcon>
    </div>
  </div>
</template>

<script>
import {inject} from "vue";
import {findIndex} from "core-js/internals/array-iteration";
import DeleteOutlineIcon from "vue-material-design-icons/DeleteOutline.vue"

export default {
  name: "Rule",
  components: {
    DeleteOutlineIcon
  },
  props: {
    rule: {
      type: Object,
      required: true
    },
    isWrong: {
      type: Boolean,
      default: false
    }
  },
  setup() {

    const column = inject('col')

    const removeRule = (rule) => {
      const index = column.value.rules.findIndex(r => r.lhs === rule.lhs && r.rhs === rule.rhs);
      column.value.rules.splice(index, 1);

      if(column.value.state == 'error') {
        column.value.state = 'editing'
      }
    }

    return {
      removeRule,
      column
    }
  }
}
</script>

<style scoped>

</style>